%% cube4
%  Recover oblique view

%%

close all
clear
load view2;

%%

% projected view
rgb1 = imread('view2.jpg');
imshow(rgb1);

%%

% ortho image
rgb = imread('vis1.jpg');
imshow(rgb);
sz = size(rgb);

%%

% calculate transform
idx = [1 2 5 4];
scale=sz(1)-1;
tpts = cp(idx,[1 3])*scale;
tpts(:,2) = scale - tpts(:,2);
cpts = pts(idx,:);
T = cp2tform(cpts,tpts,'projective');
disp(T)
disp('T.tdata');
disp(T.tdata);
disp('forward');
disp(T.tdata.T);
disp('inverse');
disp(T.tdata.Tinv);

%%

% show entire transformed image
close
im = imtransform(rgb1,T);
imshow(im);

%%

% show just the piece we are interested in
close
rng = [0 scale];
im = imtransform(rgb1,T,'XData',rng,'YData',rng);
%[im  xdata ydata] = imtransform(rgb1,T);
imshow(im);

%%

% look at differences
g1 = im2double(rgb2gray(rgb));
g2 = im2double(rgb2gray(im));
diff = g2-g1;
gmax = max(max(diff));
gmin = min(min(diff));
fprintf('max differences %g %g\n',gmax,gmin);
imshow((diff/max(gmax,-gmin)+1)/2);