%% cube6
% extract camera parameters from control points

load view2
rgb = imread('view2.jpg');
sz = size(rgb);
% normalize image coordinates to range [ -0.5 : 0.5 ] 
% (assuming square image)
p = pts/sz(2) - 0.5;
% starting point for optimization
v = [-45 35 0 -3 -3 3 1 0 -1 0];
[vfit, fmin, exitflag, options] = fminsearch(@fval1,v,optimset('MaxFunEvals',4000),p);
fprintf('%s\n',options.message);
% show results
vfit'
fprintf('camera view angle: %g\n',atan(1/vfit(7))*180/pi);
T = my_camera(vfit)

%%
% show points on image
figure(1);
imshow(rgb);
idx = [1 2 4 5 6 7 8];
show_loc(vfit,idx,sz(2));

%%
% show errors
figure(2);
show_errors(vfit,p,idx,sz(2),2);

